# Coveo Searchbox Component (CoveoSearchbox)

The `Searchbox` component allows you to conveniently instantiate two components which end users frequently use to enter and submit queries.

This component attaches itself to a `div` element and takes care of instantiating either a `Querybox` or an `Omnibox` component (see the `enableOmnibox` option). Optionally, the `Searchbox` can also instantiate a `SearchButton` component, and append it inside the same `div` (see the `addSearchButton` option).

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchButton
- searchInterface
- searchbox
- ID

### Accessors

- usageAnalytics

### Component Options

- addSearchButton
- enableOmnibox
- height

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchButton

searchButton: SearchButton

- Defined in ui/Searchbox/Searchbox.ts :105

The `SearchButton` component instance.

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### searchbox

searchbox: Querybox | Omnibox

- Defined in ui/Searchbox/Searchbox.ts :113

The component instance which allows end users to input queries.

Can be either a `Querybox` or an `Omnibox` component, depending on the value of `enableOmnibox`.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### addSearchButton

addSearchButton: boolean

- Defined in ui/Searchbox/Searchbox.ts :55

Specifies whether to instantiate a `SearchButton` component.

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-add-search-button='true'
    data-add-search-button='false'

### enableOmnibox

enableOmnibox: boolean

- Defined in ui/Searchbox/Searchbox.ts :99

Specifies whether to instantiate an `Omnibox` component.

When this option is `false`, the `Searchbox` instantiates a `Querybox` component instead.

Note:

> You can use configuration options specific to the component you choose to instantiate with the `Searchbox`.

Examples:

In this first case, the `Searchbox` instantiates a `Querybox` component. You can configure this `Querybox` instance using any of the `Querybox` component options, such as `triggerQueryOnClear`.

    <div class='CoveoSearchbox' data-trigger-query-on-clear='true'></div>

In this second case, the `Searchbox` instantiates an `Omnibox` component. You can configure this `Omnibox` instance using any of the `Omnibox` component options, such as `placeholder`. Moreover, since the `Omnibox` component inherits all of the `Querybox` component options, the `data-trigger-query-on-clear` option from the previous example would also work on this `Omnibox` instance.

    <div class='CoveoSearchbox' data-enable-omnibox='true' data-placeholder='Please enter a query'></div>

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-enable-omnibox='true'
    data-enable-omnibox='false'

### height

height: number

- Defined in ui/Searchbox/Searchbox.ts :69

A custom height for the search box (in pixels).

Note: Avoid setting this option if you want to modify the search box styling through custom CSS.

Minimum value is `25`

Default behavior: The most specific CSS rules targeting HTML elements generated by the Searchbox component are used (e.g., if you are only using the default CoveoFullSearch.css stylesheet with no further styling customizations, the search box height will be set to 50 pixels by default).

Minimum

  `25`

Available since

  July 2019 Release (v2.6459)

Markup configuration example(s) :

    data-height='10'

## Constructors

### constructor

- new Searchbox(element: HTMLElement, options?: ISearchboxOptions, bindings?: IComponentBindings): Searchbox

- Overwrites Component.constructor

  - Defined in ui/Searchbox/Searchbox.ts :113

  Creates a new `Searchbox` component. Creates a new `Coveo.Magicbox` instance and wraps magic box methods (`onblur`, `onsubmit`, etc.). Binds event on `buildingQuery` and on redirection (for standalone box).

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component. This cannot be an HTMLInputElement for technical reasons.

  - ##### Optional options: ISearchboxOptions

    The options for the `Searchbox component`. These will merge with the options from the component set directly on the `HTMLElement`.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns Searchbox